# autohelp

Security Automation Helpers for Python

Most of the modules provide wrappers for existing API clients, or are simple
API clients themselves.

- `autohelp.click` - [Click][] Helpers
- `autohelp.fastapi` - [FastAPI][]
- `autohelp.gcp` - GCP Helpers
- `autohelp.gitlab` - [python-gitlab][]
- `autohelp.hackerone` - [HackerOne API][]
- `autohelp.okta` - [Okta API][]
- `autohelp.pagerduty` - [PagerDuty API][]
- `autohelp.phonebook` - [Phonebook API][]
- `autohelp.slack` - [Slack SDK][]

[click]: https://click.palletsprojects.com/
[fastapi]: https://fastapi.tiangolo.com/
[hackerone api]: https://api.hackerone.com/
[okta api]: https://developer.okta.com/docs/reference/core-okta-api/
[pagerduty api]: https://developer.pagerduty.com/api-reference/
[phonebook api]: https://gitlab.com/gitlab-com/gl-security/engineering-and-research/automation-team/phonebook
[python-gitlab]: https://python-gitlab.readthedocs.io/
[slack sdk]: https://slack.dev/python-slack-sdk/

## Usage

Installation with [Pipenv][]:

```bash
pipenv install 'autohelp @ git+https://gitlab.com/gitlab-com/gl-security/engineering-and-research/automation-team/autohelp.git'
```

This does not install the dependencies for all modules, since they might not be
needed for a particular automation. If any of the modules below are used, make
sure to also install their dependencies via `autohelp[extra1,extra2,...]`:

| Module | Extra |
| --- | --- |
| `autohelp.click` | `click` |
| `autohelp.fastapi` | `fastapi` |
| `autohelp.gcp` | `gcp` |
| `autohelp.gitlab` | `gitlab` |
| `autohelp.slack` | `slack` |

If you are using `autohelp.phonebook`, make sure to install the
[phonebook-client][].

[pipenv]: https://pipenv.pypa.io/
[phonebook-client]: https://gitlab.com/gitlab-com/gl-security/engineering-and-research/automation-team/phonebook-client-python

## Testing

Tests can be run either from outside the Pipenv environment with `pipenv run dotenv run -- pytest --pdb`. This can also be achieved from within the environment  using `dotenv run -- pytest --pdb`.
Testing `test_flatten_members_map` and `test_get_members_map` requires a test hierarchy on staging.gitlab.com as configured in the tests and its respective serialized member maps.
These can be generated by running `tests/test_gitlab.py` using `dotenv -f ../.env run -- python test_gitlab.py`

Integration tests, if desired, can be included by using `pytest --include-integration`
